<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticsCb1 extends JPlugin
{
	function plgAnalyticsCb1( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once ( JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php' );
        cbimport( 'language.front' );
	}
	
    function onGetChartTypes(&$data, $name) {
		
		if($name != 'cb1') return;
		
		$data = array('amline', 'ampie', 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, $params, &$errors)
	{
		if($name != 'cb1') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_comprofiler', true) ) {
			$errors = '<h3>Community Builder Component Not Exists or Not Enabled<h3>';
			return;
		}
		$type = $params->get('chart_type');
		$mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		if( $type == 'ampie' ){
			$objChart->addLabel("<![CDATA[This graph shows Community Builder Registration fields relationship]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Community Builder Registration<br> fields relationship</b>]]>",15 ,25 , array('text_size' => 16));
		}else{
			$objChart->addLabel("<![CDATA[This graph shows Community Builder Registration fields progress]]>",20 ,385 , array('text_size' => 10));
			$objChart->addLabel("<![CDATA[<b>Community Builder Registration fields progress</b>]]>",90 ,25 , array('text_size' => 16));
		}
	}
	
	function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'cb1' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';

		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc  = JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		

		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}

		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}

		$form .= '</table>';

	}

	function onChartData(&$objChart, $name, $params)
	{
		if($name != 'cb1') return;

		$type = $params->get('chart_type');

		$db = JFactory::getDBO();

		$field = $params->get( 'fields' );
		$from  = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to    = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		$maxchartlines = $params->get( 'maxchartlines', 12 );
		$user_status   = $params->get( 'user_status', 'both' );
		$groupby  = $params->get( 'groupby', 'smonth' );
		
		if( !$field ) return;
        if( !is_int( $maxchartlines*1 ) ) return;
        
        $parts = explode('^',$field);
        $field = $parts[0];
        $field_type = $parts[1];
        
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$total = 0;
		
		$status_index = Array( "activated" => "AND u.block = 0",
		"blocked"   => "AND u.block = 1",
		"both"      => "");
		
	    if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(u.registerDate)",
			                      "sweek"  => "WEEKOFYEAR(u.registerDate)",
			                      "smonth" => "MONTH(u.registerDate)",
			                      "syear"  => "YEAR(u.registerDate)");
			$date_index = Array(  "sday"   => "DATE_FORMAT( u.registerDate, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( u.registerDate - INTERVAL WEEKDAY(u.registerDate) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( u.registerDate, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( u.registerDate, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(u.registerDate) AS reg_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'reg_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
			
		}

	    $sql = "   SELECT Count(c.id) AS amount,c.".$field." AS name"
		.$sql_dates
		." FROM #__comprofiler AS c
		Inner Join #__users AS u ON u.id = c.user_id "
		."\n     WHERE u.registerDate BETWEEN '".$from."' AND '".$to."' ".$status_index[$user_status];
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "\n  GROUP BY ".$sql_group." c.".$field
		."\n  ORDER BY name"
		;
		    
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		if( !$result) return;
		
	    if( $type != 'ampie' ){
			
			$current_date = $from;
	
			switch ( $groupby ) {
				case "sday":
					$format_series 		= '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			switch( $field_type ){
			    case 'multiselect':
		        case 'multicheckbox':
		            
        			foreach ( $result AS $row ) {
        			    
        			    $values = explode('|*|', $row->name);
        			    
        			    foreach ($values as $val) {
        			        
        			    	if( !$val ){
                				if( isset($graphs['--Skip--'][$row->date_index]) )
                					$graphs['--Skip--'][$row->date_index] += $row->amount;
                				else
                					$graphs['--Skip--'][$row->date_index] = $row->amount;
                			}elseif( isset($graphs[$val][$row->date_index]) )
                				    $graphs[$val][$row->date_index] += $row->amount;
                				else
                				    $graphs[$val][$row->date_index] = $row->amount;
        			    }
        			}
		            
	            break;
		        default:
			        foreach ( $result AS $row ) {
        			    if( is_null($row->name) || empty($row->name) ){
            				if( isset($graphs['--Skip--'][$row->date_index]) )
            					$graphs['--Skip--'][$row->date_index] += $row->amount;
            				else
            					$graphs['--Skip--'][$row->date_index] = $row->amount;
            			}else
            				$graphs[$row->name][$row->date_index] = $row->amount;
        			}
        		break;
		            
			}
			
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$serie = strftime( $format_series, strtotime( $current_date ) );
				$objChart->addSerie($current_date,$serie);
				if ( $type == 'amline')
				{
					foreach( $graphs as $key => $graph) {
						if( !isset($graphs[$key][$current_date]) ) {
							$graphs[$key][$current_date] = " 0 ";
						}
					}
				}
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			foreach( $graphs as $key => $graph ) {
				$objChart->addGraph($key, $key, $graph, array( 
					'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
				));
			} 
		} else {
			$slices = array();
		    switch( $field_type ){
			    case 'multiselect':
		        case 'multicheckbox':
		            
        			foreach ( $result AS $row ) {
        			    
        			    $values = explode('|*|', $row->name);
        			    foreach ($values as $val) {
        			        
        			    	if( !$val ){
                				if( isset($slices['--Skip--']) )
                					$slices['--Skip--'] += $row->amount;
                				else
                					$slices['--Skip--'] = $row->amount;
                			}elseif( isset($slices[$val]) )
                				    $slices[$val] += $row->amount;
                				else
                				    $slices[$val] = $row->amount;
        			    }
//        			    if( $row->name )
//        			        $total += $row->amount;
        			}
		            
	            break;
		        default:
        		    foreach ( $result AS $row ) {
        			    if( is_null($row->name) || empty($row->name) ){
            				if( isset($slices['--Skip--']) )
            					$slices['--Skip--'] += $row->amount;
            				else
            					$slices['--Skip--'] = $row->amount;
            			}else
            			    $slices[$row->name] = $row->amount;
//        			    $total += $row->amount;
        			}
        		break;
			}
			$i = 0;
			foreach ( $slices AS $k => $slice ) {
	            
				$pulout = $i == 0 ? 'true' : 'false';
				$objChart->addSlice($k, $slice, array( 'pull_out' => $pulout, 'alpha' => 95) );
				$i++;
			}
			/*if( $amount_users - $total > 0 ){
			    $objChart->addSlice(JText::_('--Skip--'), $amount_users - $total, array( 'pull_out' => $pulout, 'alpha' => 95) );
			}*/
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'cb1') return;

		$db = JFactory::getDBO();
		$type = $params->get('chart_type');
		
		$field = $params->get( 'fields' );
		if( !$field ) return;
		
		$from  = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to    = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		$user_status   = $params->get( 'user_status', 'both' );
		$groupby  = $params->get( 'groupby', 'smonth' );
		$maxtablecolumn = $params->get( 'maxtablecolumn', 12 );
		$limit = $params->get('limit', 0);
		$parts = explode('^',$field);
        $field = $parts[0];
        $field_type = $parts[1];
        
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		
	    $status_index = Array( "activated" => "AND u.block = 0",
		"blocked"   => "AND u.block = 1",
		"both"      => "");
		
	    if ($type != 'ampie') {
			$group_index = Array( "sday"   => "DAYOFYEAR(u.registerDate)",
			                      "sweek"  => "WEEKOFYEAR(u.registerDate)",
			                      "smonth" => "MONTH(u.registerDate)",
			                      "syear"  => "YEAR(u.registerDate)");
			$date_index = Array(  "sday"   => "DATE_FORMAT( u.registerDate, '%Y-%m-%d' )",
			                      "sweek"  => "DATE_FORMAT( u.registerDate - INTERVAL WEEKDAY(u.registerDate) DAY, '%Y-%m-%d' )",
			                      "smonth" => "DATE_FORMAT( u.registerDate, '%Y-%m-01' )",
			                      "syear"  => "DATE_FORMAT( u.registerDate, '%Y-01-01' )");
			$sql_dates = ", {$date_index[$groupby]}  AS date_index,YEAR(u.registerDate) AS reg_year, {$group_index[$groupby]} AS group_index";
			$sql_group = 'reg_year, group_index,';
		}else {
			$sql_dates = '';
			$sql_group = '';
		}
		
		$sql = "   SELECT Count(c.id) AS amount,c.".$field." AS name"
		.$sql_dates
		." FROM #__comprofiler AS c
		Inner Join #__users AS u ON u.id = c.user_id "
		."\n     WHERE u.registerDate BETWEEN '".$from."' AND '".$to."' ".$status_index[$user_status];
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "\n  GROUP BY ".$sql_group." c.".$field
		."\n  ORDER BY amount DESC 
		LIMIT 0, ".$maxtablecolumn;
		    
		$db->setQuery($sql);
		$result = $db->loadObjectList();
		
		if (!$result) return;

		if ( $type != 'ampie')
		{
		    switch( $field_type ){
			    case 'multiselect':
		        case 'multicheckbox':
		            
        			foreach ( $result AS $row ) {
        			    
        			    $values = explode('|*|', $row->name);
        			    
        			    foreach ($values as $val) {
        			        
        			    	if( !$val ){
                				if( isset($graphs['--Skip--'][$row->date_index]) )
                					$graphs['--Skip--'][$row->date_index] += $row->amount;
                				else
                					$graphs['--Skip--'][$row->date_index] = $row->amount;
                			}elseif( isset($graphs[$val][$row->date_index]) )
                				    $graphs[$val][$row->date_index] += $row->amount;
                				else
                				    $graphs[$val][$row->date_index] = $row->amount;
        			    }
        			}
		            
	            break;
		        default:
			        foreach ( $result AS $row ) {
        			    if( empty($row->name) ){
            				if( isset($graphs['--Skip--'][$row->date_index]) )
            					$graphs['--Skip--'][$row->date_index] += $row->amount;
            				else
            					$graphs['--Skip--'][$row->date_index] = $row->amount;
            			}else
            				$graphs[$row->name][$row->date_index] = $row->amount;
        			}
        		break;
		            
			}

			$k     = 0;
    		$total = 0;
    
    		$out[] = '<table class="adminlist" cellspacing="0">';
    		$out[] = '<thead>';
    		$out[] = '<tr>';
    		$out[] = '<th width="1%">#</th>';
    		foreach( $graphs as $p => $graph) {
    			$out[] = '<th class="title">'.($p != '--Skip--' ? $p : '<i><big>'.JText::_('Skip').'</big></i>').'</th>';
    		}
    		$out[] = '<th width="1%">'.JText::_('Date').'</th>';
    		$out[] = '</tr>';
    		$out[] = '</thead>';
    		$out[] = '<tbody>';
    		
    		$current_date = $from;
    		
		    switch ( $groupby ) {
				case "sday":
					$format_series 		= '%Y %d %b';
					break;
				case "sweek" :
					$timestamp = strtotime( $current_date );
					$date_info = getdate($timestamp);
					$timestamp -=  ($date_info['wday'] - 1) *60*60*24;
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %UW';
					break;
				case "smonth" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, $m[2], 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y %b';
					break;
				case "syear" :
					preg_match( "#([0-9]*)\-([0-9]*)\-([0-9]*)#", $current_date, $m );
					$timestamp = mktime (0, 0, 0, 1, 1, $m[1] );
					$current_date = date ( "Y-m-d", $timestamp );
					$format_series      = '%Y';
					break;
			}
			
		    $i = 0;
			while ( strtotime( $current_date ) <= strtotime( $to ) ) {
				$i++;
				if($limit && $i > $limit) break;
				$k = 1 - $k;
				$out[] = "<tr class='row".$k."'>";
				$out[] = "<td>".$i."</td>";
				foreach( $graphs as $key => $graph) {
					if( !isset($graphs[$key][$current_date]) ) {
						$graphs[$key][$current_date] = 0;
					}
					if( !isset($graphs[$key]['total']) ){
						$graphs[$key]['total'] = 0;
					}
					$graphs[$key]['total'] += $graphs[$key][$current_date];
					$out[] = "<td>".$graphs[$key][$current_date]."</td>";
	
				}
	
				$out[] = "<td>".$current_date."</td>";
				$out[] = "</tr>";
	
				$current_date = $this->incrementDate( $current_date, $groupby );
			}
			
			$out[] = "<tr class='row".$k."'><td><big><b>".JText::_('Total')."</b></big></td>";
			foreach( $graphs as $key => $graph) {
				$out[] = "<td><big><b>".$graphs[$key]['total']."<b></big></td>";
			}
			$out[] = "<td></td></tr>";
			
		}else{

    		$k                  = 0;
    		$total              = 0;
    		$none_of_the_listed = 0;
    
    		$out[] = '<table class="adminlist" cellspacing="0">';
    		$out[] = '<thead>';
    		$out[] = '<tr>';
    		$out[] = '<th width="1%">#</th>';
    		$out[] = '<th class="title">'.JText::_('Field Value').'</th>';
    		$out[] = '<th width="1%">'.JText::_('Users').'</th>';
    		$out[] = '</tr>';
    		$out[] = '</thead>';
    		$out[] = '<tbody>';
    
    		$i = 1;
    		$slices = array();
	        switch( $field_type ){
			    case 'multiselect':
		        case 'multicheckbox':
		            
        			foreach ( $result AS $row ) {
        			    
        			    $values = explode('|*|', $row->name);
        			    
        			    foreach ($values as $val) {
        			        
        			    	if( !$val ){
                				if( isset($slices['Skip']) )
                					$slices['Skip'] += $row->amount;
                				else
                					$slices['Skip'] = $row->amount;
                			}elseif( isset($slices[$val]) )
                				    $slices[$val] += $row->amount;
                				else
                				    $slices[$val] = $row->amount;
        			    }
        			}
		            
	            break;
		        default:
        		    foreach ( $result AS $row ) {
        			    if( is_null($row->name) || empty($row->name) ){
            				if( isset($slices['Skip']) )
            					$slices['Skip'] += $row->amount;
            				else
            					$slices['Skip'] = $row->amount;
            			}else
            			    $slices[$row->name] = $row->amount;
        			}
        		break;
			}
    		foreach ($slices AS $var => $row)
    		{
    			$total += $row;
    
    			if( $var == "" ) {
    				$none_of_the_listed += $row;
    				continue;
    			}
    			if($limit  && $i > $limit) break;
    
    			$k = 1 - $k;
    			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
    			$k, $i, $var, $row);
    			$i++ ;
    		}
		}

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}
	}

	function onGetTotals($name, $params)
	{
		if($name != 'cb1') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		$user_status   = $params->get( 'user_status', 'both' );

		$field = $params->get( 'fields' );
		$from  = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to    = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );

		if( !$field ) return;
		
		$parts = explode('^',$field);
        $field = $parts[0];
        $field_type = $parts[1];

        $status_index = Array( "activated" => "AND block = 0",
		"blocked"   => "AND block = 1",
		"both"      => "");
        
		$totals = array();

		$sql = "   SELECT Count(c.".$field.") AS amount,c.".$field." AS value 
		FROM #__comprofiler AS c
		Inner Join #__users AS u ON u.id = c.user_id "
		."\n     WHERE u.registerDate BETWEEN '".$from."' AND '".$to."' ".$status_index[$user_status];
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql .= " AND u.id = '$user_id'";
		$sql .= "\n  GROUP BY c.".$field
		."\n  ORDER BY amount DESC " ;

		$db->setQuery($sql);
		$result = $db->loadObjectList();
//		var_dump($db->getQuery());

		$sql2 = " SELECT COUNT(id) FROM #__users WHERE registerDate BETWEEN '".$from."' AND '".$to."' ";
		$db->setQuery( $sql2 );
		$db_totals = $db->loadResult();
		
		$sql2 = " SELECT COUNT(id) FROM #__users WHERE registerDate BETWEEN '".$from."' AND '".$to."' ".$status_index[$user_status];
		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
		$sql2 .= " AND id = '$user_id'";

		$db->setQuery( $sql2 );
		$amount_users = $db->loadResult();

		if(!$result && !$amount_users) return;
		$db->setQuery( $sql );
		$have =  0;
		foreach ( $result AS $k => $row ) {
			if( !$row->value ) continue;
			$have += $row->amount;

		}
		$totals[0]['value'] = $db_totals;
		$totals[0]['text'] = JText::_( 'Total users in DB');
		
		$totals[1]['value'] = $amount_users;
		$totals[1]['text'] = JText::_( 'Total users in this report');

		$totals[2]['value'] = $have;
		$totals[2]['text'] = JText::_( 'users having field value');

		$totals[3]['value'] = $amount_users - $have;
		$totals[3]['text'] = JText::_( 'users skipped field value');


		return $totals;

	}

    function incrementDate( $date, $unit )
	{
		$eDate = getDate( strtotime( $date ) );

		switch ( $unit ) {
			case "sday":
				$eDate["mday"] ++;
				break;
			case "sweek":
				$eDate["mday"] += 7;
				break;
			case "smonth":
				$eDate["mon"] ++;
				break;
			case "syear":
				$eDate["year"] ++;
				break;
		}

		return  date( 'Y-m-d', mktime( $eDate["hours"], $eDate["minutes"], $eDate["seconds"], $eDate["mon"], $eDate["mday"], $eDate["year"] ) );
	}
}
?>